<?php
//$Id$

/**
 * @file
 * Contains theme functions for the Tray
 */

/**
 * Theme function for the tray
 */
function template_preprocess_tray(&$variables) {
  $blocks = $variables['blocks'];
  $variables['items'] = array();
  foreach($blocks as $block) {
    if ($block->module && ($block->delta || $block->delta === 0)) {
      $block_name = $block->module .'_'. $block->delta;
    }
    $options = array(
      'type' => variable_get('tray_display_type_'.$block_name , 'handle'),
      'ajax' => variable_get('tray_ajax_enabled_'.$block_name , 0),
      'position' => variable_get('tray_display_position_'.$block_name , 'left'),
    );
    
    $variables['items'][$block_name]['classes_array'][] = 'tray-item';
    $variables['items'][$block_name]['classes_array'][] = ($options['type'] == 'handle') ? 'tray-item-handle' : 'tray-item-full';
    $variables['items'][$block_name]['classes_array'][] = 'tray-item-position-' . $options['position'];
    if($options['ajax']) {
      $variables['items'][$block_name]['classes_array'][] = 'tray-item-ajax-processed';
    }
    $variables['items'][$block_name]['classes'] = implode(' ', $variables['items'][$block_name]['classes_array']);
  
    $variables['items'][$block_name]['id'] = 'tray-item-' . $block->bid;
    
    $theme = ($options['type'] == 'full') ? 'tray_full' : 'tray_handle';
    $variables['items'][$block_name]['content'] =  theme($theme, array('block' => $block, 'ajax' => $options['ajax']));
  }
}

/**
 * Theme function for blocks inside the tray - display type handle
 */
function template_preprocess_tray_handle(&$variables) {
  $block = $variables['block'];
  
  $variables['title'] = $block->subject;
  $variables['minimize_btn'] = '<a href="#" class="tray-item-minimize" title="' . t('Click here to minimize this item') . '">' . t('Minimize') . '</a>';
  $variables['close_btn'] = '<a href="#" class="tray-item-close" title="' . t('Click here to close this item') . '">' . t('Close') . '</a>';
  
  $variables['content'] = '';
  if(!$variables['ajax']) {
    $renderable_block=  _block_get_renderable_array(array($block));
    //we don't need the block title in the content so let's unset this here
    $renderable_block[0]['#block']->subject = '';
    $variables['content'] = drupal_render($renderable_block);
  }
}

/**
 * Theme function for blocks inside the tray - display type full
 */
function template_preprocess_tray_full(&$variables) {
  $block = $variables['block'];
  $renderable_block=  _block_get_renderable_array(array($block));
  //we don't need the block title in the content so let's unset this here
  $renderable_block[0]['#block']->subject = '';
  $variables['content'] = drupal_render($renderable_block);
}
